@echo off 

rem (C) SSoft 2025 z-print@bk.ru
rem imposes pages in %1 file to specific layout 

if "%~1"=="" goto wrongfile
IF NOT EXIST %1 goto wrongfile

set inF="%~1"
set tempname="%inF:~1,-5%_temp.pdf"
if "%~2"=="" (
	set outF="%inF:~1,-5%_comb.pdf"
) else (
	set outF="%2"
)
set template="%~dp0%back.pdf"

echo Start processing file %inF%. Please wait... Be patient!

cpdf %inF% -mediabox "0mm 0mm 46mm 64mm" AND -shift "3mm 2mm" AND -pad-multiple 36 AND -impose-xy "1 6"  -o %tempname%
echo Stage one finished. Running stage two.  Be patient!

setlocal ENABLEDELAYEDEXPANSION
FOR /F "usebackq delims=" %%a IN (`cpdf -info %tempname% ^| find "Pages:"`) DO (set result=%%a)
set /a pages=%result:~7%
set /a sheets=pages/6

set /a LIST=1
for /L %%j in (1,1,%sheets%) do (
	for /L %%i in (%%j,%sheets%,%pages%) do (
		set LIST=!LIST!,%%i
	)
)
set LIST=%LIST:~2%

cpdf %tempname% -range %LIST% AND -impose-xy "6 1" AND -mediabox "0 0 320mm 384mm" AND -shift "28.4mm 2.15mm" AND -stamp-on %template% -o %outF%
del %tempname%
echo Done. Results in %outF% 
 
exit 0

:wrongfile
echo (C) SSoft 2025 z-print@bk.ru
echo imposes pages in given .pdf file to specific layout 
echo usage: %0 infile.pdf [outfile]
pause
